
#include <iostream>
#include <cstring>
#include <vector>
using namespace std;

string s;
vector<int> cost;
int tbl[2001][2001];
int solve(int a,int b){
	if(tbl[a][b] != -1) return tbl[a][b];
	int ans;
	if(b-a < 2){
		ans =  0;
	}else if(s[a] == s[b-1]){
		ans = solve(a+1,b-1);
	}else{
		ans = min(solve(a,b-1) + cost[s[b-1]],
							solve(a+1,b) + cost[s[a]]);
	}
	return tbl[a][b] = ans;
	
}

int main(void){
	int t,n;
	cin >> t >> n;
	cost.resize(256);
	
	cin >> s;
	while(t--){
		char c;
		int a,b;
		cin >> c >> a >> b;
		cost[c] = min(a,b);
	}
	memset(tbl,-1,sizeof(tbl));
	cout << solve(0,n) << endl;
	
	return 0;
}
